## gnuradio 3.10.12.0

=== CMakeLists.txt ===
# Copyright 2011-2021 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    message(FATAL_ERROR "Prevented in-tree build. This is bad practice.")
endif(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

# Select the release build type by default to get optimization flags.
# This has to come before project() which otherwise initializes it.
# Build type can still be overridden by setting -DCMAKE_BUILD_TYPE=
set(CMAKE_BUILD_TYPE
    "Release"
    CACHE STRING "")

########################################################################
# Project setup
########################################################################
# Make sure this version matches ${GR_CMAKE_MIN_VERSION} (a variable can't be
# used here).
cmake_minimum_required(VERSION 3.16)
project(gnuradio CXX C)
enable_testing()
option(BUILD_SHARED_LIBS "Build shared libraries" ON)

# Make sure our local CMake Modules path comes first
list(INSERT CMAKE_MODULE_PATH 0 ${PROJECT_SOURCE_DIR}/cmake/Modules)

# Add more build types and check that requested build type is valid
include(GrBuildTypes)
gr_check_build_type(${CMAKE_BUILD_TYPE})
message(STATUS "Build type set to ${CMAKE_BUILD_TYPE}.")

# Set the build date
string(TIMESTAMP BUILD_DATE "%a, %d %b %Y %H:%M:%SZ" UTC)
string(TIMESTAMP BUILD_DATE_SHORT "%Y-%m-%d" UTC)
message(STATUS "Build date set to ${BUILD_DATE}.")

include(GrComponent)

# Set the version information here
# cmake-format: off
SET(VERSION_MAJOR 3)
SET(VERSION_API   10)
SET(VERSION_ABI   12)
SET(VERSION_PATCH 0)
include(GrVersion) #setup version info
# cmake-format: on

#Set minimum version requirements
include(GrMinReq)

########################################################################
# Setup Boost for global use (within this build)
# Do this before enabling testing support, as it depends
# on unit_test_framework
########################################################################
include(GrBoost)
gr_register_component("testing-support" ENABLE_TESTING Boost_UNIT_TEST_FRAMEWORK_FOUND)

# Enable generation of compile_commands.json for code completion engines
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Set wiki block docs url prefix used in grc-docs.conf (block name gets appended to end of this string)
set(GRC_DOCS_URL_PREFIX "https://wiki.gnuradio.org/index.php/")

########################################################################
# Environment setup
########################################################################
if(NOT DEFINED BOOST_ROOT)
    set(BOOST_ROOT "${CMAKE_INSTALL_PREFIX}")
endif()

########################################################################
# Import executables from a native build (for cross compiling)
# http://www.vtk.org/Wiki/CMake_Cross_Compiling#Using_executables_in_the_build_created_during_the_build
########################################################################
if(IMPORT_EXECUTABLES)
    include(${IMPORT_EXECUTABLES})
endif(IMPORT_EXECUTABLES)

#set file that the native build will fill with exports
set(EXPORT_FILE ${PROJECT_BINARY_DIR}/ImportExecutables.cmake)
file(WRITE ${EXPORT_FILE} ) #blank the file (subdirs will append)

########################################################################
# Incorporate CMake function/macros overloading.
########################################################################

include(CMakeOverloads)

########################################################################
# Compiler settings
########################################################################

include(GrCompilerSettings)

# Record Compiler Info for record
string(TOUPPER ${CMAKE_BUILD_TYPE} GRCBTU)
set(COMPILER_INFO "")
if(MSVC)
    if(MSVC_VERSION LESS "${MSVC_MIN_VERSION}")
        message(FATAL_ERROR "MSVC Versions < minimum version ${MSVC_MIN_VERSION}")
    endif()
    set(cmake_c_compiler_version ${MSVC_VERSION})
    set(cmake_cxx_compiler_version ${MSVC_VERSION})
else()
    execute_process(COMMAND ${CMAKE_C_COMPILER} --version
                    OUTPUT_VARIABLE cmake_c_compiler_version)
    execute_process(COMMAND ${CMAKE_CXX_COMPILER} --version
                    OUTPUT_VARIABLE cmake_cxx_compiler_version)
endif(MSVC)
set(COMPILER_INFO
    "${CMAKE_C_COMPILER}:::${CMAKE_C_FLAGS_${GRCBTU}} ${CMAKE_C_FLAGS}\n${CMAKE_CXX_COMPILER}:::${CMAKE_CXX_FLAGS_${GRCBTU}} ${CMAKE_CXX_FLAGS}\n"
)

# Convert to a C string to compile and display properly
string(STRIP "${cmake_c_compiler_version}" cmake_c_compiler_version)
string(STRIP "${cmake_cxx_compiler_version}" cmake_cxx_compiler_version)
string(STRIP ${COMPILER_INFO} COMPILER_INFO)
message(STATUS "Compiler Version: ${cmake_c_compiler_version}")
message(STATUS "Compiler Flags: ${COMPILER_INFO}")
string(REPLACE "\n" " \\n" cmake_c_compiler_version ${cmake_c_compiler_version})
string(REPLACE "\n" " \\n" cmake_cxx_compiler_version ${cmake_cxx_compiler_version})
string(REPLACE "\n" " \\n" COMPILER_INFO ${COMPILER_INFO})

########################################################################
# Install directories
########################################################################
include(GrPlatform) #define LIB_SUFFIX

# Install our Cmake modules into $prefix/lib/cmake/gnuradio
# See "Package Configuration Files" on page:
#    http://www.cmake.org/Wiki/CMake/Tutorials/Packaging

if(NOT CMAKE_MODULES_DIR)
    set(CMAKE_MODULES_DIR lib${LIB_SUFFIX}/cmake)
endif(NOT CMAKE_MODULES_DIR)

# cmake-format: off
SET(GR_RUNTIME_DIR     bin CACHE PATH "Path to install all binaries")
SET(GR_LIBRARY_DIR     lib${LIB_SUFFIX} CACHE PATH "Path to install libraries")
SET(GR_INCLUDE_DIR     include CACHE PATH "Path to install header files")
SET(GR_CMAKE_DIR       ${CMAKE_MODULES_DIR}/gnuradio)
SET(GR_DATA_DIR        share CACHE PATH "Base location for data")
SET(GR_PKG_DATA_DIR    ${GR_DATA_DIR}/${CMAKE_PROJECT_NAME} CACHE PATH "Path to install package data")
SET(GR_DOC_DIR         ${GR_DATA_DIR}/doc CACHE PATH "Path to install documentation")
SET(GR_PKG_DOC_DIR     ${GR_DOC_DIR}/${CMAKE_PROJECT_NAME}-${DOCVER} CACHE PATH "Path to install package docs")
SET(GR_MAN_DIR         ${GR_DATA_DIR}/man CACHE PATH "Path to install man pages")
SET(GR_LIBEXEC_DIR     libexec CACHE PATH "Path to install libexec files")
SET(GR_PKG_LIBEXEC_DIR ${GR_LIBEXEC_DIR}/${CMAKE_PROJECT_NAME} CACHE PATH "Path to install package libexec files")
SET(GRC_BLOCKS_DIR     ${GR_PKG_DATA_DIR}/grc/blocks CACHE PATH "Path to install GRC blocks")
SET(GR_THEMES_DIR      ${GR_PKG_DATA_DIR}/themes CACHE PATH "Path to install QTGUI themes")
SET(GRC_EXAMPLES_DIR   ${GR_PKG_DATA_DIR}/examples CACHE PATH "Path to install GRC example flowgraphs")
# cmake-format: on

# Set location of config/prefs files in /etc
# Special exception if prefix is /usr so we don't make a /usr/etc.
set(GR_CONF_DIR
    etc
    CACHE PATH "Path to install config files")
string(COMPARE EQUAL "${CMAKE_INSTALL_PREFIX}" "/usr" isusr)
if(isusr)
    set(SYSCONFDIR
        "/${GR_CONF_DIR}"
        CACHE PATH "System configuration directory")
else(isusr)
    set(SYSCONFDIR
        "${CMAKE_INSTALL_PREFIX}/${GR_CONF_DIR}"
        CACHE PATH "System configuration directory" FORCE)
endif(isusr)

set(GR_PKG_CONF_DIR
    ${SYSCONFDIR}/${CMAKE_PROJECT_NAME}/conf.d
    CACHE PATH "Path to install package configs")
set(GR_PREFSDIR
    ${SYSCONFDIR}/${CMAKE_PROJECT_NAME}/conf.d
    CACHE PATH "Path to install preference files")

option(ENABLE_PERFORMANCE_COUNTERS "Enable block performance counters" ON)
if(ENABLE_PERFORMANCE_COUNTERS)
    message(STATUS "ADDING PERF COUNTERS")
    set(GR_PERFORMANCE_COUNTERS True)
else(ENABLE_PERFORMANCE_COUNTERS)
    set(GR_PERFORMANCE_COUNTERS False)
    message(STATUS "NO PERF COUNTERS")
endif(ENABLE_PERFORMANCE_COUNTERS)

string(COMPARE EQUAL "${CMAKE_INSTALL_PREFIX}" "/usr/local" isusrlocal)
string(COMPARE EQUAL "${CMAKE_INSTALL_PREFIX}" "$ENV{HOME}/.local" ishomelocal)

option(ENABLE_BASH_COMPLETIONS "Enable shell completions for bash" ON)
if(ENABLE_BASH_COMPLETIONS)
    if(NOT DEFINED GR_BASH_COMPLETIONS_DIR)
        if(isusr OR isusrlocal OR ishomelocal)
            set(GR_BASH_COMPLETIONS_DIR
                share/bash-completion/completions
                CACHE PATH "Path to install bash completions")
        else(isusr OR isusrlocal OR ishomelocal)
            message(WARNING "GR_BASH_COMPLETIONS_DIR is not defined")
            set(ENABLE_BASH_COMPLETIONS OFF)
        endif(isusr OR isusrlocal OR ishomelocal)
    endif(NOT DEFINED GR_BASH_COMPLETIONS_DIR)
endif(ENABLE_BASH_COMPLETIONS)

option(ENABLE_ZSH_COMPLETIONS "Enable shell completions for zsh" ON)
if(ENABLE_ZSH_COMPLETIONS)
    if(NOT DEFINED GR_ZSH_COMPLETIONS_DIR)
        if(isusr OR isusrlocal)
            set(GR_ZSH_COMPLETIONS_DIR
                share/zsh/site-functions
                CACHE PATH "Path to install zsh completions")
        else(isusr OR isusrlocal)
            message(WARNING "GR_ZSH_COMPLETIONS_DIR is not defined")
            set(ENABLE_ZSH_COMPLETIONS OFF)
        endif(isusr OR isusrlocal)
    endif(NOT DEFINED GR_ZSH_COMPLETIONS_DIR)
endif(ENABLE_ZSH_COMPLETIONS)

option(ENABLE_FISH_COMPLETIONS "Enable shell completions for fish" ON)
if(ENABLE_FISH_COMPLETIONS)
    if(NOT DEFINED GR_FISH_COMPLETIONS_DIR)
        if(isusr OR ishomelocal)
            set(GR_FISH_COMPLETIONS_DIR
                share/fish/vendor_completions.d
                CACHE PATH "Path to install fish completions")
        else(isusr OR ishomelocal)
            message(WARNING "GR_FISH_COMPLETIONS_DIR is not defined")
            set(ENABLE_FISH_COMPLETIONS OFF)
        endif(isusr OR ishomelocal)
    endif(NOT DEFINED GR_FISH_COMPLETIONS_DIR)
endif(ENABLE_FISH_COMPLETIONS)

########################################################################
# Variables replaced when configuring the package config files
########################################################################
# cmake-format: off
file(TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}"           prefix)
file(TO_CMAKE_PATH "\${prefix}"                        exec_prefix)
file(TO_CMAKE_PATH "\${exec_prefix}/${GR_LIBRARY_DIR}" libdir)
file(TO_CMAKE_PATH "\${prefix}/${GR_INCLUDE_DIR}"      includedir)
file(TO_CMAKE_PATH "${SYSCONFDIR}"                     SYSCONFDIR)
file(TO_CMAKE_PATH "${GR_PREFSDIR}"                    GR_PREFSDIR)
# cmake-format: on

if(WIN32)
    file(RELATIVE_PATH prefix_relative_to_lib "${prefix}/${GR_RUNTIME_DIR}" "${prefix}")
else(WIN32)
    file(RELATIVE_PATH prefix_relative_to_lib "${prefix}/${GR_LIBRARY_DIR}" "${prefix}")
endif(WIN32)
file(RELATIVE_PATH SYSCONFDIR_relative_to_prefix "${prefix}" "${SYSCONFDIR}")
file(RELATIVE_PATH GR_PREFSDIR_relative_to_prefix "${prefix}" "${GR_PREFSDIR}")

########################################################################
# On Apple only, set install name and use rpath correctly, if not already set
########################################################################
if(APPLE)
    if(NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR}
            CACHE PATH "Library Install Name Destination Directory" FORCE)
    endif(NOT CMAKE_INSTALL_NAME_DIR)
    if(NOT CMAKE_INSTALL_RPATH)
        set(CMAKE_INSTALL_RPATH
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR}
            CACHE PATH "Library Install RPath" FORCE)
    endif(NOT CMAKE_INSTALL_RPATH)
    if(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
        set(CMAKE_BUILD_WITH_INSTALL_RPATH
            ON
            CACHE BOOL "Do Build Using Library Install RPath" FORCE)
    endif(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
endif(APPLE)

########################################################################
# Create uninstall target
########################################################################

=== gr-analog/CMakeLists.txt ===
# Copyright 2012,2019 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
# Nobody here but us chickens

########################################################################
# Register component
########################################################################
include(GrComponent)
gr_register_component("gr-analog" ENABLE_GR_ANALOG ENABLE_GNURADIO_RUNTIME
                      ENABLE_GR_BLOCKS ENABLE_GR_FFT ENABLE_GR_FILTER)

set(GR_PKG_ANALOG_EXAMPLES_DIR ${GR_PKG_DATA_DIR}/examples/analog)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_ANALOG)

    ########################################################################
    # Add subdirectories
    ########################################################################
    add_subdirectory(include/gnuradio/analog)
    add_subdirectory(lib)
    add_subdirectory(docs)
    if(ENABLE_PYTHON)
        add_subdirectory(python/analog)
        if(ENABLE_EXAMPLES)
            add_subdirectory(examples)
            add_subdirectory(examples/tags)
        endif(ENABLE_EXAMPLES)
    endif(ENABLE_PYTHON)
    if(ENABLE_GRC)
        add_subdirectory(grc)
    endif(ENABLE_GRC)

    ########################################################################
    # Create Pkg Config File
    ########################################################################
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-analog.pc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-analog.pc @ONLY)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-analog.pc
            DESTINATION ${GR_LIBRARY_DIR}/pkgconfig)

endif(ENABLE_GR_ANALOG)

=== gr-audio/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################

########################################################################
# Register component
########################################################################
include(GrComponent)
gr_register_component("gr-audio" ENABLE_GR_AUDIO ENABLE_GNURADIO_RUNTIME)

set(GR_PKG_AUDIO_EXAMPLES_DIR ${GR_PKG_DATA_DIR}/examples/audio)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_AUDIO)

    ########################################################################
    # Add subdirectories
    ########################################################################
    add_subdirectory(lib)
    add_subdirectory(include/gnuradio/audio)
    add_subdirectory(docs)
    if(ENABLE_PYTHON)
        add_subdirectory(python/audio)
        if(ENABLE_EXAMPLES)
            add_subdirectory(examples/python)
            add_subdirectory(examples/grc)
        endif(ENABLE_EXAMPLES)
    endif(ENABLE_PYTHON)
    if(ENABLE_GRC)
        add_subdirectory(grc)
    endif(ENABLE_GRC)
    if((ENABLE_GR_ANALOG) AND (ENABLE_EXAMPLES))
        add_subdirectory(examples/c++)
    endif((ENABLE_GR_ANALOG) AND (ENABLE_EXAMPLES))

    ########################################################################
    # Create Pkg Config File
    ########################################################################
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-audio.pc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-audio.pc @ONLY)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-audio.pc
            DESTINATION ${GR_LIBRARY_DIR}/pkgconfig)

endif(ENABLE_GR_AUDIO)

=== gr-channels/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################

########################################################################
# Register component
########################################################################
include(GrComponent)

gr_register_component(
    "gr-channels"
    ENABLE_GR_CHANNELS
    ENABLE_GNURADIO_RUNTIME
    ENABLE_GR_BLOCKS
    ENABLE_GR_FFT
    ENABLE_GR_FILTER
    ENABLE_GR_ANALOG)

set(GR_PKG_CHANNELS_EXAMPLES_DIR ${GR_PKG_DATA_DIR}/examples/channels)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_CHANNELS)

    ########################################################################
    # Add subdirectories
    ########################################################################
    add_subdirectory(include/gnuradio/channels)
    add_subdirectory(lib)
    if(ENABLE_PYTHON)
        add_subdirectory(python/channels)
        if(ENABLE_EXAMPLES)
            add_subdirectory(examples)
        endif(ENABLE_EXAMPLES)
    endif(ENABLE_PYTHON)
    if(ENABLE_GRC)
        add_subdirectory(grc)
    endif(ENABLE_GRC)
    add_subdirectory(docs)

    ########################################################################
    # Create Pkg Config File
    ########################################################################
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-channels.pc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-channels.pc @ONLY)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-channels.pc
            DESTINATION ${GR_LIBRARY_DIR}/pkgconfig)

endif(ENABLE_GR_CHANNELS)

=== gr-trellis/CMakeLists.txt ===
# Copyright 2012,2019 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
# ↺↺↺↺↺↺↺ (Tumbleweed)

########################################################################
# Register component
########################################################################
include(GrComponent)
gr_register_component("gr-trellis" ENABLE_GR_TRELLIS ENABLE_GNURADIO_RUNTIME
                      ENABLE_GR_ANALOG ENABLE_GR_BLOCKS ENABLE_GR_DIGITAL)

set(GR_PKG_TRELLIS_EXAMPLES_DIR ${GR_PKG_DATA_DIR}/examples/trellis)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_TRELLIS)

    ########################################################################
    # Add subdirectories
    ########################################################################
    add_subdirectory(include/gnuradio/trellis)
    add_subdirectory(lib)
    add_subdirectory(docs)
    if(ENABLE_PYTHON)
        add_subdirectory(python/trellis)
        if(ENABLE_EXAMPLES)
            add_subdirectory(examples/python)
            add_subdirectory(examples/grc)
        endif(ENABLE_EXAMPLES)
    endif(ENABLE_PYTHON)
    if(ENABLE_GRC)
        add_subdirectory(grc)
    endif(ENABLE_GRC)

    ########################################################################
    # Create Pkg Config File
    ########################################################################
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-trellis.pc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-trellis.pc @ONLY)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-trellis.pc
            DESTINATION ${GR_LIBRARY_DIR}/pkgconfig)

endif(ENABLE_GR_TRELLIS)

=== gr-uhd/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
include(GrBoost)

find_package(UHD "3.9.7")
if("${UHD_VERSION}" VERSION_GREATER_EQUAL "4")
    set(UHD_FOUR_POINT_OH_RFNOC TRUE)
else()
    set(UHD_FOUR_POINT_OH_RFNOC FALSE)
endif()

gr_python_check_module("PyQt5" PyQt5 True PYQT5_FOUND)

########################################################################
# Register component
########################################################################
include(GrComponent)
gr_register_component(
    "gr-uhd"
    ENABLE_GR_UHD
    Boost_FOUND
    UHD_FOUND
    ENABLE_GNURADIO_RUNTIME
    ENABLE_GR_FILTER
    ENABLE_GR_BLOCKS
    ENABLE_GR_ANALOG)
set(GR_PKG_UHD_EXAMPLES_DIR ${GR_PKG_DATA_DIR}/examples/uhd)

gr_register_component("gr-uhd UHD 4.0 RFNoC" ENABLE_UHD_RFNOC ENABLE_GR_UHD
                      UHD_FOUR_POINT_OH_RFNOC)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_UHD)
    message(STATUS "  UHD Version: ${UHD_VERSION}")

    ########################################################################
    # Add subdirectories
    ########################################################################
    add_subdirectory(include/gnuradio/uhd)
    add_subdirectory(lib)
    add_subdirectory(docs)
    if(ENABLE_EXAMPLES)
        add_subdirectory(examples/c++)
    endif(ENABLE_EXAMPLES)
    if(ENABLE_PYTHON)
        add_subdirectory(python/uhd)
        add_subdirectory(apps)
        if(ENABLE_EXAMPLES)
            add_subdirectory(examples/grc)
        endif(ENABLE_EXAMPLES)
    endif(ENABLE_PYTHON)
    if(ENABLE_GRC)
        add_subdirectory(grc)
    endif(ENABLE_GRC)

    ########################################################################
    # Create Pkg Config File
    ########################################################################
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-uhd.pc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-uhd.pc @ONLY)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-uhd.pc
            DESTINATION ${GR_LIBRARY_DIR}/pkgconfig)

endif(ENABLE_GR_UHD)

=== gr-utils/CMakeLists.txt ===
# Copyright 2011,2012,2020 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
include(GrPython)

gr_python_check_module(
    "Mako >= ${GR_MAKO_MIN_VERSION}" mako
    "LooseVersion(mako.__version__) >= LooseVersion('${GR_MAKO_MIN_VERSION}')" MAKO_FOUND)

gr_python_check_module_raw("click" "import click" CLICK_FOUND)

########################################################################
# Register component
########################################################################
include(GrComponent)
if(NOT CMAKE_CROSSCOMPILING)
    set(utils_python_deps MAKO_FOUND)

    set(utils_modtool_deps CLICK_FOUND)

endif(NOT CMAKE_CROSSCOMPILING)

gr_register_component("gr-utils" ENABLE_GR_UTILS ENABLE_GNURADIO_RUNTIME ENABLE_PYTHON
                      ${utils_python_deps})

gr_register_component("gr_modtool" ENABLE_GR_MODTOOL ENABLE_GNURADIO_RUNTIME
                      ENABLE_PYTHON ${utils_modtool_deps})

gr_register_component("gr_blocktool" ENABLE_GR_BLOCKTOOL ENABLE_GNURADIO_RUNTIME
                      ENABLE_PYTHON)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_UTILS)

    ########################################################################
    # Add subdirectories
    ########################################################################
    add_subdirectory(plot_tools)
    add_subdirectory(read_file_metadata)

    if(ENABLE_GR_BLOCKTOOL)
        add_subdirectory(blocktool)
    endif(ENABLE_GR_BLOCKTOOL)

    if(ENABLE_GR_MODTOOL)
        add_subdirectory(bindtool)
        add_subdirectory(modtool)
    endif(ENABLE_GR_MODTOOL)

endif(ENABLE_GR_UTILS)

=== gr-video-sdl/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
find_package(SDL)

########################################################################
# Register component
########################################################################
include(GrComponent)
GR_REGISTER_COMPONENT("gr-video-sdl" ENABLE_GR_VIDEO_SDL
    SDL_FOUND
    ENABLE_GNURADIO_RUNTIME
)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_VIDEO_SDL)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(include/gnuradio/video_sdl)
add_subdirectory(lib)
if(ENABLE_PYTHON)
    add_subdirectory(python/video_sdl)
endif(ENABLE_PYTHON)
if(ENABLE_GRC)
    add_subdirectory(grc)
endif(ENABLE_GRC)

########################################################################
# Create Pkg Config File
########################################################################
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-video-sdl.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-video-sdl.pc
@ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-video-sdl.pc
    DESTINATION ${GR_LIBRARY_DIR}/pkgconfig
)

endif(ENABLE_GR_VIDEO_SDL)

=== gr-zeromq/CMakeLists.txt ===
# Copyright 2013 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#


########################################################################
# Setup dependencies
########################################################################
find_package(ZeroMQ)

########################################################################
# Register component
########################################################################
include(GrComponent)

GR_REGISTER_COMPONENT("gr-zeromq" ENABLE_GR_ZEROMQ
    ENABLE_GNURADIO_RUNTIME
    ZEROMQ_FOUND
    CPPZMQ_HAS_SHUTDOWN
)

SET(GR_PKG_ZEROMQ_EXAMPLES_DIR ${GR_PKG_DATA_DIR}/examples/zeromq)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_ZEROMQ)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(include/gnuradio/zeromq)
add_subdirectory(lib)
if(ENABLE_PYTHON)
    add_subdirectory(python/zeromq)
    if(ENABLE_EXAMPLES)
        add_subdirectory(examples)
    endif(ENABLE_EXAMPLES)
endif(ENABLE_PYTHON)
if(ENABLE_GRC)
    add_subdirectory(grc)
endif(ENABLE_GRC)

########################################################################
# Create Pkg Config File
########################################################################
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-zeromq.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-zeromq.pc
@ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-zeromq.pc
    DESTINATION ${GR_LIBRARY_DIR}/pkgconfig
)

endif(ENABLE_GR_ZEROMQ)

=== gnuradio-runtime/lib/CMakeLists.txt ===
# Copyright 2013,2018 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

include(GrMiscUtils)
gr_check_hdr_n_def(sys/resource.h HAVE_SYS_RESOURCE_H)

########################################################################
# Look for libunwind
########################################################################
find_package(libunwind)

########################################################################
# Handle the generated constants
########################################################################
message(STATUS "Loading build date ${BUILD_DATE} into constants...")
message(STATUS "Loading version ${VERSION} into constants...")

#Generate the constants file, now that we actually know which components will be enabled.
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/constants.cc.in
               ${CMAKE_CURRENT_BINARY_DIR}/constants.cc ESCAPE_QUOTES @ONLY)

#########################################################################
# Include subdirs rather to populate to the sources lists.
########################################################################
add_subdirectory(pmt)

########################################################################
# Setup library
########################################################################

#Generate sine table header file for Math part of library
set(MATH_SINE_TABLE_HEADER ${CMAKE_CURRENT_BINARY_DIR}/math/generated/sine_table.h)
set(MATH_SINE_TABLE_GENERATOR ${CMAKE_CURRENT_SOURCE_DIR}/math/gen_sine_table.py)
execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory
                        "${CMAKE_CURRENT_BINARY_DIR}/math/generated")
add_custom_command(
    DEPENDS ${MATH_SINE_TABLE_GENERATOR}
    OUTPUT ${MATH_SINE_TABLE_HEADER}
    COMMAND ${PYTHON_EXECUTABLE} ${MATH_SINE_TABLE_GENERATOR} > ${MATH_SINE_TABLE_HEADER})

add_library(
    gnuradio-runtime
    ${CMAKE_CURRENT_BINARY_DIR}/constants.cc
    basic_block.cc
    block.cc
    block_detail.cc
    block_executor.cc
    block_registry.cc
    buffer.cc
    buffer_double_mapped.cc
    buffer_reader.cc
    buffer_reader_sm.cc
    buffer_single_mapped.cc
    dictionary_logger_backend.cc
    flat_flowgraph.cc
    flowgraph.cc
    hier_block2.cc
    hier_block2_detail.cc
    high_res_timer.cc
    host_buffer.cc
    io_signature.cc
    local_sighandler.cc
    logger.cc
    message.cc
    msg_accepter.cc
    msg_handler.cc
    msg_queue.cc
    pagesize.cc
    pdu.cc
    pmt_fmt.cc
    prefs.cc
    realtime.cc
    realtime_impl.cc
    scheduler.cc
    scheduler_tpb.cc
    sptr_magic.cc
    sync_block.cc
    sync_decimator.cc
    sync_interpolator.cc
    sys_paths.cc
    tagged_stream_block.cc
    terminate_handler.cc
    top_block.cc
    top_block_impl.cc
    tpb_detail.cc
    tpb_thread_body.cc
    transfer_type.cc
    vmcircbuf.cc
    vmcircbuf_createfilemapping.cc
    vmcircbuf_mmap_shm_open.cc
    vmcircbuf_mmap_tmpfile.cc
    vmcircbuf_prefs.cc
    vmcircbuf_sysv_shm.cc)

# Messages
target_sources(
    gnuradio-runtime
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/messages/msg_accepter.cc
            ${CMAKE_CURRENT_SOURCE_DIR}/messages/msg_accepter_msgq.cc
            ${CMAKE_CURRENT_SOURCE_DIR}/messages/msg_producer.cc
            ${CMAKE_CURRENT_SOURCE_DIR}/messages/msg_queue.cc)

# Thread
target_sources(
    gnuradio-runtime
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/thread/thread.cc
            ${CMAKE_CURRENT_SOURCE_DIR}/thread/thread_body_wrapper.cc
            ${CMAKE_CURRENT_SOURCE_DIR}/thread/thread_group.cc)

# Math
target_include_directories(gnuradio-runtime PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/math)
target_sources(
    gnuradio-runtime
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/math/fast_atan2f.cc
            ${CMAKE_CURRENT_SOURCE_DIR}/math/fxpt.cc
            ${CMAKE_CURRENT_SOURCE_DIR}/math/random.cc ${MATH_SINE_TABLE_HEADER})

target_link_libraries(
    gnuradio-runtime
    PUBLIC
        gnuradio-pmt
        Volk::volk
        Boost::thread
        spdlog::spdlog
        MPLib::mplib
    PRIVATE
        Boost::program_options
        libunwind::libunwind)

# Address linker issues with std::filesystem on Centos 8 and Debian
target_link_libraries(
    gnuradio-runtime
    PUBLIC
        $<$<AND:$<CXX_COMPILER_ID:GNU>,$<VERSION_LESS:$<CXX_COMPILER_VERSION>,9.0>>:stdc++fs>
)

target_include_directories(
    gnuradio-runtime
    PUBLIC $<INSTALL_INTERFACE:include>
           $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
           $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/../include>
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

target_compile_features(gnuradio-runtime PUBLIC cxx_std_17)

target_compile_definitions(gnuradio-runtime PUBLIC ${MPLIB_DEFINITIONS})

# constants.cc includes boost::dll headers, force them to use std::filesystem
target_compile_definitions(gnuradio-runtime PRIVATE BOOST_DLL_USE_STD_FS)

if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.16.0")
    target_precompile_headers(
        gnuradio-runtime PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/../include/gnuradio/sync_block.h)
endif()

########################################################################
# Add controlport stuff to gnuradio-runtime
########################################################################
# Controlport
if(ENABLE_GR_CTRLPORT)

    # Keep track of the number of backends ControlPort supports
    set(CTRLPORT_BACKENDS 0)

    target_sources(
        gnuradio-runtime
        PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/controlport/rpcmanager.cc
                ${CMAKE_CURRENT_SOURCE_DIR}/controlport/rpcserver_aggregator.cc
                ${CMAKE_CURRENT_SOURCE_DIR}/controlport/rpcserver_booter_aggregator.cc
                ${CMAKE_CURRENT_SOURCE_DIR}/controlport/rpcserver_selector.cc)

    if(ENABLE_CTRLPORT_THRIFT)
        math(EXPR CTRLPORT_BACKENDS "${CTRLPORT_BACKENDS} + 1")

        # Indicate thrift as an installed backend in the cmake summary.
        message(STATUS "Enabling Thrift backend to ControlPort")
        gr_append_subcomponent("thrift")

        # Run Thrift To compile C++ and Python files
        message(STATUS "Running thrift to build C++ bindings")
        file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/controlport/thrift/)

        list(
            APPEND
            gnuradio_thrift_generated_sources
            ${CMAKE_CURRENT_BINARY_DIR}/controlport/thrift/gnuradio_types.cpp
            ${CMAKE_CURRENT_BINARY_DIR}/controlport/thrift/gnuradio_constants.cpp
            ${CMAKE_CURRENT_BINARY_DIR}/controlport/thrift/ControlPort.cpp)
        add_custom_command(
            DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/controlport/thrift/gnuradio.thrift
            OUTPUT ${gnuradio_thrift_generated_sources}
            COMMAND
                ${THRIFT_BIN} --gen cpp -out
                ${CMAKE_CURRENT_BINARY_DIR}/controlport/thrift/
                ${CMAKE_CURRENT_SOURCE_DIR}/controlport/thrift/gnuradio.thrift)

        target_include_directories(
            gnuradio-runtime
            PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/controlport>)

        target_sources(
            gnuradio-runtime
            PRIVATE
                ${CMAKE_CURRENT_SOURCE_DIR}/controlport/thrift/rpcserver_thrift.cc
                ${CMAKE_CURRENT_SOURCE_DIR}/controlport/thrift/rpcpmtconverters_thrift.cc
                ${CMAKE_CURRENT_SOURCE_DIR}/controlport/thrift/rpcserver_booter_thrift.cc
                ${CMAKE_CURRENT_SOURCE_DIR}/controlport/thrift/thrift_application_base.cc
                # add files built by compiling gnuradio.thrift
                ${gnuradio_thrift_generated_sources})
        target_link_libraries(gnuradio-runtime PRIVATE Thrift::thrift)

        target_compile_definitions(gnuradio-runtime PUBLIC GR_CTRLPORT)

        # Add install rule to move example Thrift configuration file into a
        # documentation directory
        install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/controlport/thrift/thrift.conf.example
                DESTINATION ${GR_PKG_DOC_DIR}/config)

    endif(ENABLE_CTRLPORT_THRIFT)

    # Save the number of backends for testing against later
    set(CTRLPORT_BACKENDS
        ${CTRLPORT_BACKENDS}
        CACHE INTERNAL "Number of ControlPort backends available")

endif(ENABLE_GR_CTRLPORT)

########################################################################
# Add misc conditional includes/definitions to gnuradio-runtime
########################################################################

if(ENABLE_PERFORMANCE_COUNTERS)
    target_compile_definitions(gnuradio-runtime PUBLIC -DGR_PERFORMANCE_COUNTERS)
endif()

if(GR_IS_BIG_ENDIAN)
    target_compile_definitions(gnuradio-runtime PUBLIC -DGR_IS_BIG_ENDIAN)
endif(GR_IS_BIG_ENDIAN)

if(MSVC)
    target_compile_definitions(
        gnuradio-runtime
        PUBLIC # Minimum version: "Windows Server 2003 with SP1, Windows XP with SP2"
               -D_WIN32_WINNT=0x0502
               # disables stupidity and enables std::min and std::max
               -DNOMINMAX
               # stop all kinds of compatibility warnings
               -D_SCL_SECURE_NO_WARNINGS
               -D_CRT_SECURE_NO_WARNINGS
               -D_CRT_SECURE_NO_DEPRECATE
               -D_CRT_NONSTDC_NO_DEPRECATE)
endif(MSVC)

if(WIN32)
    target_compile_definitions(gnuradio-runtime PUBLIC -D_USE_MATH_DEFINES)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        target_compile_definitions(gnuradio-runtime PUBLIC -DMS_WIN64)
    endif(CMAKE_SIZEOF_VOID_P EQUAL 8)
endif(WIN32)

if(WIN32)
    target_compile_definitions(gnuradio-runtime PUBLIC -DWIN32_LEAN_AND_MEAN)
endif(WIN32)

#need to link with librt on ubuntu 11.10 and Hurd for shm_*
if((LINUX) OR (CMAKE_SYSTEM_NAME MATCHES "^(kFreeBSD|GNU)$"))
    target_link_libraries(gnuradio-runtime PUBLIC rt)
endif()

########################################################################
# Add DLL resource file when using MSVC
########################################################################

if(MSVC)
    include(${PROJECT_SOURCE_DIR}/cmake/Modules/GrVersion.cmake)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-runtime.rc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-runtime.rc @ONLY)

    target_sources(gnuradio-runtime
                   PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-runtime.rc)
endif(MSVC)

########################################################################
# Control availability of vmcircbuf methods.
# For now, only allows disabling of shm methods, which cause uncatchable
#    segmentation faults on Cygwin with gcc 4.x (x <= 5)
# Usage:
#   GR_VMCIRCBUF()
#
# Will set TRY_SHM_VMCIRCBUF to 1 by default except on Windows machines.
# Can manually set with -DTRY_SHM_VMCIRCBUF=0|1
########################################################################

if(WIN32)
    option(TRY_SHM_VMCIRCBUF "Try SHM VMCIRCBUF" OFF)
else(WIN32)
    option(TRY_SHM_VMCIRCBUF "Try SHM VMCIRCBUF" ON)
endif(WIN32)

message(STATUS "TRY_SHM_VMCIRCBUF set to ${TRY_SHM_VMCIRCBUF}.")

if(TRY_SHM_VMCIRCBUF)
    target_compile_definitions(gnuradio-runtime PRIVATE -DTRY_SHM_VMCIRCBUF)
endif(TRY_SHM_VMCIRCBUF)

gr_library_foo(gnuradio-runtime)

########################################################################
# Setup tests
########################################################################
if(ENABLE_TESTING)
    include(GrTest)

    # Regular runtime tests:
    list(
        APPEND
        test_gnuradio_runtime_sources
        qa_buffer.cc
        qa_io_signature.cc
        qa_logger.cc
        qa_dictionary_logger.cc
        qa_host_buffer.cc
        qa_vmcircbuf.cc)
    list(APPEND GR_TEST_TARGET_DEPS gnuradio-runtime gnuradio-pmt)

    foreach(qa_file ${test_gnuradio_runtime_sources})
        gr_add_cpp_test("runtime_${qa_file}" ${CMAKE_CURRENT_SOURCE_DIR}/${qa_file})
        target_link_libraries("runtime_${qa_file}" spdlog::spdlog)
    endforeach(qa_file)

    # Math tests:
    list(
        APPEND
        test_gnuradio_math_sources
        qa_fxpt.cc

=== gr-analog/docs/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

install(FILES README.analog DESTINATION ${GR_PKG_DOC_DIR})

=== gr-analog/examples/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

include(GrPython)

# Base stuff
gr_python_install(PROGRAMS fmtest.py fm_demod.py
                  DESTINATION ${GR_PKG_ANALOG_EXAMPLES_DIR})

install(FILES noise_power.grc fm_rx.grc fm_tx.grc USRP_FM_stereo.grc
              sig_source_msg_ports.grc DESTINATION ${GR_PKG_ANALOG_EXAMPLES_DIR})

=== debian/changelog ===
gnuradio (3.10.12.0-5) unstable; urgency=medium

  * Simplify autopkgtest

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 17 Oct 2025 14:33:39 -0400

gnuradio (3.10.12.0-4) unstable; urgency=medium

  * update to v3.10.12.0-42-gd8814e0c3e
  * rebuild with newer pybind11 3.x in unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 16 Oct 2025 00:43:24 -0400

gnuradio (3.10.12.0-3) unstable; urgency=medium

  * Apply Switch-to-standard-GNUInstallDirs-fix.patch (Closes:#1115817)

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 19 Sep 2025 18:00:06 -0400

gnuradio (3.10.12.0-2) unstable; urgency=medium

  * update to v3.10.12.0-41-gc234c76c77 recent upstream fixes
  * skip PDF documentation build in forky (Closes: #1114129)
  * drop the unused python3-click-plugins dependency (Closes: #1108452)
  * Update standards version to 4.7.2, no changes needed.
  * Use Switch-to-standard-GNUInstallDirs.patch

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 18 Sep 2025 23:51:15 -0400

gnuradio (3.10.12.0-1) unstable; urgency=medium

  * New upstream release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 24 Feb 2025 22:40:00 -0500

gnuradio (3.10.12.0~rc1-2) experimental; urgency=medium

  * more fixups

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 08 Feb 2025 21:42:13 -0500

gnuradio (3.10.12.0~rc1-1) experimental; urgency=medium

  * New upstream release.
    GRC-Qt fixes and parity with the Gtk version
    UHD/RFNoC updates
    CI, modtool, and other devel/infrastructure updates
  * upload to experimenal for soversion bump

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 24 Jan 2025 10:29:40 -0500

=== debian/control ===
Source: gnuradio
Section: comm
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends-Indep: doxygen-latex
Build-Depends: cmake (>= 3.16.3),
               cppzmq-dev [!hurd-amd64],
               debhelper-compat (= 13),
               dh-python,
               dpkg-dev (>= 1.22.5),
               gir1.2-gtk-3.0,
               gir1.2-pango-1.0,
               graphviz,
               libad9361-dev [linux-any],
               libasound2-dev,
               libboost-date-time-dev,
               libboost-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libcodec2-dev,
               libcppunit-dev,
               libfftw3-dev,
               libfontconfig-dev,
               libgmp-dev,
               libgsl-dev,
               libgsm1-dev,
               libiio-dev [linux-any],
               libjack-jackd2-dev,
               libjs-mathjax,
               libpulse-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libqwt-qt5-dev,
               libsdl1.2-dev,
               libsndfile1-dev,
               libsoapysdr-dev,
               libspdlog-dev,
               libthrift-dev (>= 0.13.0-5) [amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64],
               libuhd-dev (>= 4),
               libunwind-dev [amd64 arm64 armel armhf hppa i386 ia64 loong64 mipsel mips64el powerpc ppc64 ppc64el sh4],
               libusb-1.0-0-dev [!kfreebsd-any],
               libusb2-dev [kfreebsd-any],
               libvolk-dev,
               libxi-dev,
               libxrender-dev,
               ninja-build,
               pkgconf,
               portaudio19-dev,
               pybind11-dev,
               python3-click,
               python3-dev,
               python3-gi,
               python3-gi-cairo,
               python3-jsonschema,
               python3-lxml,
               python3-mako,
               python3-numpy-dev,
               python3-opengl,
               python3-packaging,
               python3-pygccxml (>=2.5.0) [linux-amd64 arm64 armel armhf i386 ppc64el riscv64 s390x],
               python3-pyqt5 [!hurd-amd64],
               python3-pytest,
               python3-schema,
               python3-scipy,
               python3-thrift [amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64el riscv64 s390x],
               python3-yaml,
               python3-zmq [!hurd-amd64],
               qt5-qmake,
               qtbase5-dev,
               qttools5-dev,
               thrift-compiler [amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64el riscv64 s390x],
               xauth,
               xmlto
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.gnuradio.org/
Vcs-Browser: https://salsa.debian.org/bottoms/pkg-gnuradio
Vcs-Git: https://salsa.debian.org/bottoms/pkg-gnuradio.git

Package: gnuradio
Architecture: any
Depends: gnome-terminal | x-terminal-emulator,
         libjs-mathjax,
         libvolk-bin,
         python3-click,
         python3-gi,
         python3-gi-cairo,
         python3-jsonschema,
         python3-lxml,
         python3-mako,
         python3-numpy,
         python3-opengl,
         python3-packaging,
         python3-pygccxml [linux-amd64 arm64 armel armhf i386 ppc64el riscv64 s390x],
         python3-pyqt5 [!hurd-amd64],
         python3-pyqtgraph,
         python3-schema,
         python3-thrift [amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64el riscv64 s390x],
         python3-yaml,
         python3-zmq [!hurd-amd64],
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: gnuradio-dev,
            python3-matplotlib,
            python3-networkx,
            python3-pygccxml (>= 2.0),
            python3-pyqt5.qwt,
            python3-scipy,
            soapysdr-tools
Suggests: gqrx-sdr, gr-fosphor, gr-osmosdr, rtl-sdr, uhd-host
Breaks: gr-iio, gr-soapy
Replaces: gr-iio, gr-soapy
Multi-Arch: foreign
Description: GNU Radio Software Radio Toolkit
 GNU Radio provides signal processing blocks to implement software
 radios. It can be used with readily-available low-cost external RF
 hardware to create software-defined radios, or without hardware in a
 simulation-like environment. It is widely used in hobbyist, academic
 and commercial environments to support both wireless communications
 research and real-world radio systems.
 .
 GNU Radio applications are primarily written using the Python
 programming language, while the supplied performance-critical signal
 processing path is implemented in C++ using processor floating-point
 extensions, where available. Thus, the developer is able to implement
 real-time, high-throughput radio systems in a simple-to-use,
 rapid-application-development environment.
 .
 While not primarily a simulation tool, GNU Radio does support
 development of signal processing algorithms using pre-recorded or
 generated data, avoiding the need for actual RF hardware.
 .
 This package contains the gnuradio-companion, a graphical tool for
 creating signal flow graphs and generating flow-graph source code.
 Also included are a variety of tools and utility programs.

Package: gnuradio-doc
Section: doc
Architecture: all
Depends: libjs-mathjax, ${misc:Depends}
Multi-Arch: foreign
Description: GNU Software Defined Radio toolkit documentation
 Documentation for the GNU Radio software defined radio system
 in html and PDF form.
 .
 HTML docs start file:///usr/share/doc/gnuradio-doc/html/index.html
 .
 PDF docs in file:///usr/share/doc/gnuradio-doc/refman.pdf.gz
 .
 Part of the main gnuradio build.

Package: gnuradio-dev
Section: libdevel
Architecture: any
Breaks: gr-iio
Replaces: gr-iio
Pre-Depends: ${misc:Pre-Depends}
Depends: gnuradio (>= ${binary:Version}),
         libboost-date-time${boost-version}-dev,
         libboost-filesystem${boost-version}-dev,
         libboost-program-options${boost-version}-dev,
         libboost-regex${boost-version}-dev,
         libboost-system${boost-version}-dev,
         libboost-test${boost-version}-dev,
         libboost-thread${boost-version}-dev,
         libcppunit-dev,
         libfftw3-dev,
         libgmp-dev,
         libgsm1-dev,
         libspdlog-dev,
         libthrift-dev [amd64 arm64 armel armhf i386],
         libvolk-dev,
         pkgconf,
         pybind11-dev,
         python3-dev,
         ${misc:Depends}
Suggests: cmake, libqwt-qt5-dev, qtbase5-dev
Description: GNU Software Defined Radio toolkit development
 Header files for the GNU Radio software defined radio system.
 Since GNU Radio is a framework for development of SDR
 applications, you are likely to need this installed.
 .
 Part of the main gnuradio build.

Package: libgnuradio-analog3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio analog functions
 Library for handling analog signal processing functions.
 These functions are also in gnuradio-core.
 Part of the main gnuradio build.

Package: libgnuradio-audio3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio audio functions
 This is the gr-audio library, used to connect to audio sources
 (mic-in) and sinks (speaker-out) ports on a computer. The underlying
 hardware driver is system and OS dependent and this module should
 automatically discover the correct one to use.  Part of the main
 gnuradio build.

Package: libgnuradio-blocks3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio blocks functions
 Some non-signal processing blocks.
 These functions are also in gnuradio-core.
 Part of the main gnuradio build.

Package: libgnuradio-channels3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio channels functions
 Some channel oriented processing blocks.
 These functions are also in gnuradio-core.
 Part of the main gnuradio build.

Package: libgnuradio-digital3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio digital communications functions
 All the functions for doing digital modulation and demodulation,
 including bpsk, qpsk, gmsk and ofdm signals.
 Part of the main gnuradio build.

Package: libgnuradio-dtv3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio digital TV signal processing blocks
 ATSC support, gr-atsc ported to a new framework, as well as
 DVB-S2, DVB-T, DVB-T2 digital video broadcast standards.
 Part of the main gnuradio build.

Package: libgnuradio-fec3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio forward error correction support
 Handle forward error correction processing in gnuradio.
 Implements the GNU Radio FEC API, supporting encoders and
 decoders for no-op dummmy, repetition, and convolutional classes.
 Part of the main gnuradio build.

Package: libgnuradio-fft3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio fast Fourier transform functions
 Library for Fourier transform techniques used in gnuradio.
 Uses single precision FFT from libfftw3-single3.
 Part of the main gnuradio build.

Package: libgnuradio-filter3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio filter functions
 Library of filter blocks used in gnuradio. Implements
 FIR, IIR and FFT filters, as well as Polyphase filterbank and
 PFB arbitrary resampler methods.
 Part of the main gnuradio build.

Package: libgnuradio-iio3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: IIO blocks for GnuRadio
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 The IIO blocks for GnuRadio can be used to create flowgraphs that interface
 IIO devices through libiio.
 .
 Part of the main gnuradio build.

Package: libgnuradio-network3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio network library
 Library of  blocks that implement UDP and TCP source and
 sink blocks supporting both IPv4 and IPv6.
 Part of the main gnuradio build.

Package: libgnuradio-pdu3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: gnuradio streaming protocol library
 Protocol Data Units library provides signal processing
 blocks that operate on Protocol Data Unit format messages. Many
 such blocks are analogs of streaming API functionality.
 Part of the main gnuradio build.

Package: libgnuradio-pmt3.10.12
Provides: ${t64:Provides}
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}

=== debian/tests/control ===
Tests: python
Depends: gnuradio, python3-all, python3-numpy
Restrictions: superficial

=== debian/watch ===
version=4
 opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,uversionmangle=s/-rc/~rc/" \
 https://github.com/gnuradio/gnuradio/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
